/// <reference types="node" />
import { PropertyData, PlatformData, LockerData, BurnData, BurnRoleData, VestingData } from "../types";
/**
 * Static abstract class definition to parse entities.
 * @category Parsables
 */
export interface ParsableEntity<T> {
    /**
     * Parse account data
     *
     * @param accountData Buffer data for the entity
     * @returns Parsed entity
     */
    parse: (accountData: Buffer | undefined | null) => T | null;
}
export declare class ParsablePlatform {
    private constructor();
    static parse(data: Buffer | undefined | null): PlatformData | null;
}
export declare class ParsableProperty {
    private constructor();
    static parse(data: Buffer | undefined | null): PropertyData | null;
}
export declare class ParsableLocker {
    private constructor();
    static parse(data: Buffer | undefined | null): LockerData | null;
}
export declare class ParsableVesting {
    private constructor();
    static parse(data: Buffer | undefined | null): VestingData | null;
}
export declare class ParsableBurnRole {
    private constructor();
    static parse(data: Buffer | undefined | null): BurnRoleData | null;
}
export declare class ParsableBurn {
    private constructor();
    static parse(data: Buffer | undefined | null): BurnData | null;
}
