/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { BN, Program } from "@project-serum/anchor";
import { PropeasyProgram } from "../artifacts/propeasy_program";
export type SwapTokenParams = {
    accounts: {
        authority: PublicKey;
        platformState: PublicKey;
        burnRoleState: PublicKey;
        burnState: PublicKey;
        burnMintAccount: PublicKey;
        purchaseMintAccount: PublicKey;
        oracle: PublicKey;
        tickArray0: PublicKey;
        tickArray1: PublicKey;
        tickArray2: PublicKey;
        tokenOwnerAccountA: PublicKey;
        tokenOwnerAccountB: PublicKey;
        whirlpoolTokenVaultA: PublicKey;
        whirlpoolTokenVaultB: PublicKey;
        whirlpool: PublicKey;
        whirlpoolProgram: PublicKey;
    };
    inputs: {
        otherAmountThreshold: BN;
        sqrtPriceLimit: BN;
        aToB: boolean;
    };
};
export declare function swapToken(program: Program<PropeasyProgram>, params: SwapTokenParams): Promise<Instruction>;
