/// <reference types="bn.js" />
import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program, BN } from "@project-serum/anchor";
import { PropeasyProgram } from "../artifacts/propeasy_program";
export type WithdrawTokenParams = {
    accounts: {
        admin: PublicKey;
        platformState: PublicKey;
        propertyState: PublicKey;
        propertyMintAccount: PublicKey;
        withdrawMintAccount: PublicKey;
        withdrawVaultTokenAccount: PublicKey;
        beneficiary: PublicKey;
        beneficiaryWithdrawTokenAccount: PublicKey;
    };
    inputs: {
        amount: BN;
    };
};
export declare function withdrawToken(program: Program<PropeasyProgram>, params: WithdrawTokenParams): Promise<Instruction>;
