"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PDA = exports.BURN_SEED = exports.BURN_ROLE_SEED = exports.VESTING_SEED = exports.LOCKER_SEED = exports.PROPERTY_STATE_SEED = exports.PLATFORM_STATE_SEED = void 0;
const anchor = __importStar(require("@project-serum/anchor"));
exports.PLATFORM_STATE_SEED = "propeasy";
exports.PROPERTY_STATE_SEED = "property";
exports.LOCKER_SEED = "locker";
exports.VESTING_SEED = "vesting";
exports.BURN_ROLE_SEED = "burn_role";
exports.BURN_SEED = "burn";
class PDA {
    constructor(programId) {
        this.platform = () => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.PLATFORM_STATE_SEED)], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.property = (propertyMintAccount) => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.PROPERTY_STATE_SEED), propertyMintAccount.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.locker = (user, propertyState) => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.LOCKER_SEED), user.toBuffer(), propertyState.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.vesting = (user, propertyState) => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.VESTING_SEED), user.toBuffer(), propertyState.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.burnRole = (user) => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.BURN_ROLE_SEED), user.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.burn = (token) => {
            const [pda, bump] = anchor.web3.PublicKey.findProgramAddressSync([anchor.utils.bytes.utf8.encode(exports.BURN_SEED), token.toBuffer()], this.programId);
            return {
                key: pda,
                bump: bump,
            };
        };
        this.programId = programId;
    }
}
exports.PDA = PDA;
